/*
* Template: src/main/takatuka/templates/EntityPresentationAbstractSearchView.vm
*/
package de.ivu.elect.presentation.niederschrift;

import java.util.List;

import javax.annotation.PostConstruct;
import javax.enterprise.context.RequestScoped;
import javax.enterprise.event.Observes;
import javax.enterprise.event.Reception;
import javax.enterprise.inject.Instance;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;
import org.apache.deltaspike.core.api.scope.ViewAccessScoped;

import de.ivu.elect.business.security.UseCasePermission;

import de.ivu.elect.business.niederschrift.boundary.AbstractNiederschriftStatusAenderungSearchParameters;
import de.ivu.elect.business.niederschrift.boundary.NiederschriftStatusAenderungChangeEvent;
import de.ivu.elect.business.niederschrift.boundary.NiederschriftStatusAenderungConversationStore;
import de.ivu.elect.business.niederschrift.boundary.NiederschriftStatusAenderungExtendedDAO;
import de.ivu.elect.business.niederschrift.boundary.NiederschriftStatusAenderungSearch;
import de.ivu.elect.business.niederschrift.boundary.NiederschriftStatusAenderungSearchParameters;
import de.ivu.elect.business.wahl.boundary.WahlSelectChangeEvent;
import de.ivu.elect.business.wahl.boundary.WahlterminSelectChangeEvent;
import de.ivu.elect.business.niederschrift.entity.NiederschriftStatusAenderung;
import de.ivu.elect.business.niederschrift.entity.NiederschriftStatusAenderungMeta;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.presentation.AbstractElectSearchView;
import de.ivu.elect.presentation.View;

@ViewAccessScoped
@Named(AbstractNiederschriftStatusAenderungSearchView.COMPONENT_NAME)
@View(viewId = AbstractNiederschriftStatusAenderungSearchView.VIEW_ID, useCase = UseCasePermission.NIEDERSCHRIFT_STATUS_AENDERUNG_SEARCH)
public abstract class AbstractNiederschriftStatusAenderungSearchView extends AbstractElectSearchView<NiederschriftStatusAenderung> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "niederschriftStatusAenderungSearchView";
  
  public static final String VIEW_ID = "/niederschrift/niederschrift-status-aenderung-search.xhtml";

  @Inject
  private transient RequestHandlerAbstractNiederschriftStatusAenderungSearchView requestHandler;

  @Inject
  private transient NiederschriftStatusAenderungExtendedDAO extendedDAO;

  @Inject
  @ConversationGroup(NiederschriftStatusAenderungConversationStore.class)
  protected transient NiederschriftStatusAenderungConversationStore conversationStore;

  @Inject
  protected transient NiederschriftStatusAenderungSearch search;

  @Inject
  @ConversationGroup(AbstractNiederschriftStatusAenderungSearchParameters.class)
  protected transient NiederschriftStatusAenderungSearchParameters searchParameters;

  @Inject
  protected transient NiederschriftStatusAenderungMeta entityMeta;

  public AbstractNiederschriftStatusAenderungSearchView() {
    super();
  }

  @Override
  protected String getViewId() {
    return VIEW_ID;
  }

  public boolean isEntitySelected() {
    return conversationStore.getEntityPK() != null;
  }

  public NiederschriftStatusAenderung getSelectedEntity() {
    if (isEntitySelected()) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }

    return null;
  }

  public void setSelectedEntity(NiederschriftStatusAenderung entity) {
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  @Override
  public NiederschriftStatusAenderungSearchParameters getSearchParameters() {
    return searchParameters;
  }

  public EagerLoadingCollector<NiederschriftStatusAenderung> getEagerLoadingCollector() {
    return EagerLoadingCollector.<NiederschriftStatusAenderung> create();
  }

  @Override
  public List<NiederschriftStatusAenderung> getSearchResult() {
    requestHandler.nothing(); // ELECT-248

    return super.getSearchResult();
  }

  @Override
  protected List<NiederschriftStatusAenderung> performSearch() {
    return search.getSearchResult(getSearchParameters(), getEagerLoadingCollector());
  }

  public void onNiederschriftStatusAenderungChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) NiederschriftStatusAenderungChangeEvent event) {
    resetSearchResult();
  }

  // ELECT-2231    ELECT-2250
  /*
   * searchParameters sind von der zur Bearbeitung ausgewählten Wahl abhängig.
   */
  public void onWahlSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlSelectChangeEvent event) {
    reset();
  }

  /*
   * searchParameters sind vom zur Bearbeitung ausgewählten Wahltermin abhängig.
   */
  public void onWahlterminSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlterminSelectChangeEvent event) {
    reset();
  }

  @RequestScoped
  //  Das Suchergebnis soll nur einmal pro Request geladen werden, daher gibt es dieses "Konstrukt" aus "SearchView" und "RequestHandlerAbstract"
  public static class RequestHandlerAbstractNiederschriftStatusAenderungSearchView {

    @View
    @Inject
    private transient Instance<AbstractNiederschriftStatusAenderungSearchView> searchViews;

    @PostConstruct
    public void init() {
      // ELECT-3543 Doppelte Suchen vermeiden - Suchergebnis für Request nicht beim POST-löschen
      if (!FacesContext.getCurrentInstance().isPostback()) {
        for (AbstractNiederschriftStatusAenderungSearchView searchView : searchViews) {
          searchView.resetSearchResult();
        }
      }
    }

    public void nothing() {
      // Do nothing.
    }
  }
}
